# coding: utf-8

"""
    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import re  # noqa: F401
import io
import warnings
import functools

from pydantic import validate_arguments, ValidationError
from typing_extensions import Annotated

from pydantic import Field, StrictStr

from circle.web3.smart_contract_platform.models.deploy_contract_template200_response import DeployContractTemplate200Response
from circle.web3.smart_contract_platform.models.estimate_contract_template_deploy200_response import EstimateContractTemplateDeploy200Response
from circle.web3.smart_contract_platform.models.estimate_deploy_contract_by_template_fee_request import EstimateDeployContractByTemplateFeeRequest
from circle.web3.smart_contract_platform.models.template_contract_deployment_request import TemplateContractDeploymentRequest

from circle.web3.smart_contract_platform.api_client import ApiClient
from circle.web3.smart_contract_platform.api_response import ApiResponse
from circle.web3.smart_contract_platform.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


def auto_fill(func):
    functools.wraps(func)

    def wrapper(*args, **kwargs):
        api = args[0]
        for arg in args:
            api.api_client.fill_entity_secret_ciphertext(arg)
            api.api_client.fill_idempotency_key(arg)
        for name, arg in kwargs.items():
            api.api_client.fill_entity_secret_ciphertext(arg)
            api.api_client.fill_idempotency_key(arg)
        return func(*args, **kwargs)

    return wrapper


class TemplatesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @auto_fill
    @validate_arguments
    def deploy_contract_template(self, id : Annotated[StrictStr, Field(..., description="Template id")], template_contract_deployment_request : Annotated[TemplateContractDeploymentRequest, Field(..., description="Deploy contract by template request.")], **kwargs) -> DeployContractTemplate200Response:  # noqa: E501
        """Deploy a contract from a template  # noqa: E501

        Deploy a smart contract using a template.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.deploy_contract_template(id, template_contract_deployment_request, async_req=True)
        >>> result = thread.get()

        :param id: Template id (required)
        :type id: str
        :param template_contract_deployment_request: Deploy contract by template request. (required)
        :type template_contract_deployment_request: TemplateContractDeploymentRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: DeployContractTemplate200Response
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the deploy_contract_template_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.deploy_contract_template_with_http_info(id, template_contract_deployment_request, **kwargs)  # noqa: E501

    @auto_fill
    @validate_arguments
    def deploy_contract_template_with_http_info(self, id : Annotated[StrictStr, Field(..., description="Template id")], template_contract_deployment_request : Annotated[TemplateContractDeploymentRequest, Field(..., description="Deploy contract by template request.")], **kwargs) -> ApiResponse:  # noqa: E501
        """Deploy a contract from a template  # noqa: E501

        Deploy a smart contract using a template.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.deploy_contract_template_with_http_info(id, template_contract_deployment_request, async_req=True)
        >>> result = thread.get()

        :param id: Template id (required)
        :type id: str
        :param template_contract_deployment_request: Deploy contract by template request. (required)
        :type template_contract_deployment_request: TemplateContractDeploymentRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(DeployContractTemplate200Response, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'template_contract_deployment_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method deploy_contract_template" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['template_contract_deployment_request'] is not None:
            _body_params = _params['template_contract_deployment_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['BearerAuth']  # noqa: E501

        _response_types_map = {
            '200': "DeployContractTemplate200Response",
            '201': "DeployContractTemplate200Response",
        }

        return self.api_client.call_api(
            '/templates/{id}/deploy', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @auto_fill
    @validate_arguments
    def estimate_contract_template_deploy(self, id : Annotated[StrictStr, Field(..., description="Template id")], estimate_deploy_contract_by_template_fee_request : Annotated[EstimateDeployContractByTemplateFeeRequest, Field(..., description="Request object for estimating the transaction fees for deploying a contract from a template.")], **kwargs) -> EstimateContractTemplateDeploy200Response:  # noqa: E501
        """Estimate fee for a contract template deployment  # noqa: E501

        Estimate the fee required to deploy contract by template.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.estimate_contract_template_deploy(id, estimate_deploy_contract_by_template_fee_request, async_req=True)
        >>> result = thread.get()

        :param id: Template id (required)
        :type id: str
        :param estimate_deploy_contract_by_template_fee_request: Request object for estimating the transaction fees for deploying a contract from a template. (required)
        :type estimate_deploy_contract_by_template_fee_request: EstimateDeployContractByTemplateFeeRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: EstimateContractTemplateDeploy200Response
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the estimate_contract_template_deploy_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.estimate_contract_template_deploy_with_http_info(id, estimate_deploy_contract_by_template_fee_request, **kwargs)  # noqa: E501

    @auto_fill
    @validate_arguments
    def estimate_contract_template_deploy_with_http_info(self, id : Annotated[StrictStr, Field(..., description="Template id")], estimate_deploy_contract_by_template_fee_request : Annotated[EstimateDeployContractByTemplateFeeRequest, Field(..., description="Request object for estimating the transaction fees for deploying a contract from a template.")], **kwargs) -> ApiResponse:  # noqa: E501
        """Estimate fee for a contract template deployment  # noqa: E501

        Estimate the fee required to deploy contract by template.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.estimate_contract_template_deploy_with_http_info(id, estimate_deploy_contract_by_template_fee_request, async_req=True)
        >>> result = thread.get()

        :param id: Template id (required)
        :type id: str
        :param estimate_deploy_contract_by_template_fee_request: Request object for estimating the transaction fees for deploying a contract from a template. (required)
        :type estimate_deploy_contract_by_template_fee_request: EstimateDeployContractByTemplateFeeRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(EstimateContractTemplateDeploy200Response, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'id',
            'estimate_deploy_contract_by_template_fee_request'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method estimate_contract_template_deploy" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}
        if _params['id']:
            _path_params['id'] = _params['id']


        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['estimate_deploy_contract_by_template_fee_request'] is not None:
            _body_params = _params['estimate_deploy_contract_by_template_fee_request']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['BearerAuth']  # noqa: E501

        _response_types_map = {
            '200': "EstimateContractTemplateDeploy200Response",
        }

        return self.api_client.call_api(
            '/templates/{id}/deploy/estimateFee', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
